diff --git a/Zend/zend.c b/Zend/zend.c
index 5f9325cb31c35..7ebd5c10b8845 100644
--- a/Zend/zend.c
+++ b/Zend/zend.c
@@ -1368,6 +1368,9 @@ ZEND_API ZEND_COLD void zend_error_zstr_at(
 		EG(num_errors)++;
 		EG(errors) = erealloc(EG(errors), sizeof(zend_error_info) * EG(num_errors));
 		EG(errors)[EG(num_errors)-1] = info;
+		if (EG(record_errors_without_emitting)) {
+			return;
+		}
 	}
 
 	/* Report about uncaught exception in case of fatal errors */
@@ -1629,6 +1632,35 @@ ZEND_API void zend_begin_record_errors(void)
 	EG(errors) = NULL;
 }
 
+static inline void zend_begin_record_errors_ex(bool no_emmitting)
+{
+	ZEND_ASSERT(!EG(record_errors) && "Error recording already enabled");
+	EG(record_errors) = true;
+	EG(record_errors_without_emitting) = no_emmitting;
+	EG(num_errors) = 0;
+	EG(errors) = NULL;
+}
+
+ZEND_API void zend_begin_record_errors(void)
+{
+	zend_begin_record_errors_ex(false);
+}
+
+ZEND_API void zend_begin_record_errors_without_emitting(void)
+{
+	zend_begin_record_errors_ex(true);
+}
+
+ZEND_API void zend_emit_recorded_errors(void)
+{
+	EG(record_errors) = false;
+	for (uint32_t i = 0; i < EG(num_errors); i++) {
+		zend_error_info *error = EG(errors)[i];
+		zend_error_zstr_at(
+			error->type, error->filename, error->lineno, error->message);
+	}
+}
+
 ZEND_API void zend_free_recorded_errors(void)
 {
 	if (!EG(num_errors)) {
diff --git a/Zend/zend_globals.h b/Zend/zend_globals.h
index 1726dee9ac12a..83a7e7a62c43c 100644
--- a/Zend/zend_globals.h
+++ b/Zend/zend_globals.h
@@ -261,8 +261,10 @@ struct _zend_executor_globals {
 	zend_long fiber_stack_size;
 
 	/* If record_errors is enabled, all emitted diagnostics will be recorded,
-	 * in addition to being processed as usual. */
+	 * in addition to being processed as usual unless record_errors_without_emitting
+	 * is enabled which supresses processing when the errors are recorded. */
 	bool record_errors;
+	bool record_errors_without_emitting;
 	uint32_t num_errors;
 	zend_error_info **errors;
 
diff --git a/ext/opcache/ZendAccelerator.c b/ext/opcache/ZendAccelerator.c
index 5f6b854d477d0..d19d3b1db6de2 100644
--- a/ext/opcache/ZendAccelerator.c
+++ b/ext/opcache/ZendAccelerator.c
@@ -3929,12 +3929,7 @@ static void preload_link(void)
 
 						/* Inheritance successful, print out any warnings. */
 						zend_error_cb = orig_error_cb;
-						EG(record_errors) = false;
-						for (uint32_t i = 0; i < EG(num_errors); i++) {
-							zend_error_info *error = EG(errors)[i];
-							zend_error_zstr_at(
-								error->type, error->filename, error->lineno, error->message);
-						}
+						zend_emit_recorded_errors();
 					} zend_catch {
 						/* Clear variance obligations that were left behind on bailout. */
 						if (CG(delayed_variance_obligations)) {
diff --git a/main/streams/transports.c b/main/streams/transports.c
index de6b968868ed9..3125029c286e7 100644
--- a/main/streams/transports.c
+++ b/main/streams/transports.c
@@ -131,6 +131,9 @@ PHPAPI php_stream *_php_stream_xport_create(const char *name, size_t namelen, in
 			(char*)name, namelen, persistent_id, options, flags, timeout,
 			context STREAMS_REL_CC);
 
+
+	zend_begin_record_errors_without_emitting();
+
 	if (stream) {
 		php_stream_context_set(stream, context);
 
@@ -181,6 +184,9 @@ PHPAPI php_stream *_php_stream_xport_create(const char *name, size_t namelen, in
 		stream = NULL;
 	}
 
+	zend_emit_recorded_errors();
+	zend_free_recorded_errors();
+
 	return stream;
 }
 
